#ifndef BUFFER_H
#define BUFFER_H

#include "glew.h"
#include <vector>

#define BUFFER_OFFSET(i) ((char *)NULL + (i))

class Buffer
{
public:
    enum BufferType
    {
       VBO,
       EBO,
       UBO
    };

    virtual ~Buffer();
    virtual void bind() = 0;
    virtual void unbind() = 0;
};

template <typename T>
class TBuffer : public Buffer
{
public:
   class BufferEditor
   {
         GLenum m_typeEnum;
         T *ptr;
         
      public:
         BufferEditor(TBuffer *b);
         ~BufferEditor();
         
         T* getPointer();
   };
   
    TBuffer(const std::vector<T> &data, BufferType type, bool isDynamic = false);
    ~TBuffer();
    
    virtual void setVertexAttrib(int location, int nbComponents, int offset = 0, int instanceDivisor = 0);
    
    virtual void bind();
    virtual void unbind();

    GLuint getId() {return m_id;}
    BufferType getType() {return m_type;}
    bool isDynamic() {return m_isDynamic;}
    
private:
    GLuint m_id;
    BufferType m_type;
    bool m_isDynamic;
    
    GLenum getGLEnum(BufferType type);
};

#endif // BUFFER_H
